/* $Id: a.c,v 1.3 2009/03/02 16:54:26 kostik Exp $ */

#include <dlfcn.h>
#include <stdio.h>

int a_data = 0;

void
a_func(void)
{
	void *handle;
	void (*b_func)(void);

	printf("a_func\n");
	handle = dlopen("b.so", RTLD_LAZY);
	if (handle == NULL) {
		fprintf(stderr, "dlopen: %s\n", dlerror());
		return;
	}
	b_func = (void (*)(void))dlsym(handle, "b_func");
	if (b_func == NULL) {
		fprintf(stderr, "dlfunc: %s\n", dlerror());
	} else {
		printf("a_data %d\n", a_data);
		b_func();
		printf("a_data %d\n", a_data);
	}
	dlclose(handle);
}
