/* $Id: main.c,v 1.4 2009/03/02 20:27:02 kostik Exp kostik $ */

#include <dlfcn.h>
#include <stdio.h>
#include <stdlib.h>

int
main(int argc, char *argv[])
{
	void *handle;
	void (*a_func)(void);

	handle = dlopen("a.so", RTLD_LAZY | /*RTLD_LOCAL*/RTLD_GLOBAL);
	if (handle == NULL) {
		fprintf(stderr, "dlopen: %s\n", dlerror());
		exit(1);
	}
	if (handle == NULL) {
		fprintf(stderr, "dlopen: %s\n", dlerror());
		exit(1);
	}
	a_func = (void (*)(void))dlsym(handle, "a_func");
	if (a_func == NULL) {
		fprintf(stderr, "dlfunc: %s\n", dlerror());
	} else {
		a_func();
	}
	dlclose(handle);
	exit(0);
}
